﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_ResetBindingTest
{
    public partial class Form1 : Form
    {
        UltraGridLayout oLayout;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetDataSource();
        }

        private void SetDataSource()
        {
            oLayout = new UltraGridLayout();
            oLayout.CopyFrom(ultraGrid1.DisplayLayout);

            DataSet oDS = GetMeSomeData();
            ultraGrid1.SetDataBinding( null, null );
            ultraGrid1.SetDataBinding( oDS, null );

            ultraGrid1.DisplayLayout.CopyFrom(oLayout);
        }

        private DataSet GetMeSomeData()
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add("table1");

            for (int i = 0; i < 20; i++)
            {
                dt.Columns.Add("Column " + i, typeof(string));
            }

            for (int i = 0; i < 10000; i++)
            {
                var rowData = new object[dt.Columns.Count];
                for (int j = 0; j < dt.Columns.Count; j++)
                {
                    rowData[j] = String.Format("Row {0} Column {1}", i, j);
                }
                dt.Rows.Add(rowData);
            }
            return ds;
        }


        private void ultraButton1_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 100; i++)
            {
                SetDataSource();
            }
            // Force the GC to collect any unreferenced objects
            GC.WaitForPendingFinalizers();
            GC.Collect();
            GC.WaitForPendingFinalizers();
        }
    }
}
